/*
 * File: parser.cpp
 *
 * Written by Peter Horak in 2012 at Dartmouth College for the GreenCube project,
 * supervised by Professor Kristina Lynch.
 *
 * Purpose: parse binary serial data from the Bob payload
 */

#include <iostream>
#include <iomanip>
#include <string>
#include <sstream>
#include <fstream>

#include <stdint.h>
#include <stdio.h>
#include <math.h>

using namespace std;

// Used to find the start of each data group
const char data_sentinel = '#';

int main(int argc, char **argv)
{
    // To hold the data
    uint32_t time; // 4 bytes (unsigned int)
    int16_t data[11]; // 2 bytes each (short)
    char c; // 1 byte
    
    // Convert the data into text and output it to the data buffer
    do {
        // Find the start of a line
        while (c != data_sentinel)
            cin.read((&c),sizeof(c));
        // Parse a data line
        if (c == data_sentinel)
        {
            // micros() timestamp
            cin.read(reinterpret_cast<char *>(&time),sizeof(time));
            cout << time << ' ';

            // Compass data etc
            for (int i = 0; i < sizeof(data)/sizeof(data[0]); i++)
            {
                cin.read(reinterpret_cast<char *>(&data[i]),sizeof(data[i]));
                cout << setw(5) << data[i] << ' ';
            }

            // Update c so it is no longer the previous sentinel
            cin.read((&c),sizeof(c));
            cout << endl;
        }
    } while (cin && !cin.eof());

}

